*   Written By;
*   Curt Cadwell
*   Just Software Inc.
*   7154 N. University Dr.
*   Suite 294
*   Tamarac, Fl. 33321
*   (305) 978-9695
*   Compuserv (72411,3655)

*   Here is simple program that I created and would like to contribute 
*   back to the FOXFORUM. Thanks to all of you for your help now and in the
*   future.
 
*   Example of how to use DDE with  WINFAX PRO 3.0 and WORD 2.0c.
*   The program first activates WINFAX and WORD. It proceeds to open a 
*   customer data base with 5 records and selects each record one at a time
*   for a print merge to WORD. Also before each print merge the WINFAX PRO 
*   info is poked with the fax number,name,time,date. What happens is you 
*   will end up with 5 faxes going to different people. Don't worry WINFAX
*   won't send it because the date is set for 1995.
*   You can also send the 
*   same document to multiple people if you use multiple pokes before you 
*   print to the winfax driver. This is explained in the WINFAX manual.

*   YOU MAY NEED TO CHANGE A COUPLE OF THINGS.
*    This program is set up to look for files in C:\foxtest
*    Also the WINFAX printer driver is set up for com1: You'll need to change
*    that line if your driver is on a different com port. Don't forget to 
*    exactly match the driver name upper and lower case per your word print 
*    setup.
    
SET SAFETY OFF
SET TALK OFF
set default to c:\foxtest
*
*Start WORD and WINFAX PRO 3.0 
*
=ddesetoption("TIMEOUT",4000)    && change timeout value 2000 wasn't enough
RUN /N c:\winfax\faxmng            && activate winfax pro
FAX1 = DDEInitiate("FAXMNG", "Transmit")  && open channel
IF FAX1 = -1             && cannot establish channel
  DO FAXERR WITH 26
  RETURN
ENDIF
RUN /N c:\winword\winword            && activate word
WORD1 = DDEInitiate("WinWord", "System")   && open channel
IF WORD1 = -1             && cannot establish channel
  DO FAXERR WITH 26
  RETURN
ENDIF

USE CUSTOMER IN 0          && open file
DO WHILE NOT EOF()
  COPY NEXT 1 TO MERGE      && copy record for print merge
  SKIP	                       
  SELECT 0
  USE MERGE                    && open customer file
  snumber = ALLTRIM(RPHONE)    && load fax number 
  stime  = "11:30:30"          && time to send fax
  sdate  = "06/21/95"          && date to send fax
  sname  = ALLTRIM(CONTACT)       && name of recipient of fax
  scompany = ALLTRIM(COMPANY)     &&  company to send fax to
  ssubject = "this is a test of winfax"  && subject of fax
  skeywords = "event keywords"           && keywords
  sbilling  = "6250-18"                  && billing code
  USE                          && close customer
  SELECT CUSTOMER              && open test file
* 
* build command for winfax pro
*
  recipient = 'recipient("'+(snumber)+'","'+(stime)+'","'+(sdate)+;
    '","'+(sname)+'","'+(scompany)+'","'+(ssubject)+'","'+(skeywords)+;
    '","'+(sbilling)+'")'

  =ddepoke(FAX1,"Sendfax",(recipient)) && stuff command into winfax print driver
  IF DDElasterror() <> 0             && if last dde not 0 call err routine
    DO FAXERR WITH DDElasterror()
    RETURN
  ENDIF
  

*
*DDE calls to Microsoft Word 2.0c
*

  = DDEExecute(WORD1, '[FileOpen "c:\foxtest\Just.doc"]')   && open document
  IF DDElasterror() <> 0             && if last dde not 0 call err routine
    DO FAXERR WITH DDElasterror()
    RETURN
  ENDIF

* Change statement to exactly match your file print setup
                                               
  = DDEExecute(WORD1, '[FilePrintSetup "WINFAX on COM1:"]')   && make sure winfax is default
  IF DDElasterror() <> 0             && if last dde not 0 call err routine
    DO FAXERR WITH DDElasterror()
    RETURN
  ENDIF

  = DDEExecute(WORD1, "[FilePrintMergeToDoc]")    && merge to new document
  IF DDElasterror() <> 0             && if last dde not 0 call err routine
    DO FAXERR WITH DDElasterror()
    RETURN
  ENDIF

  = DDEExecute(WORD1, "[File1]")                  && open new document
  IF DDElasterror() <> 0             && if last dde not 0 call err routine
    DO FAXERR WITH DDElasterror()
    RETURN
  ENDIF

  = DDEExecute(WORD1, "[FileClose 2]")            && close old document
  IF DDElasterror() <> 0             && if last dde not 0 call err routine
    DO FAXERR WITH DDElasterror()
    RETURN
  ENDIF

  = DDEExecute(WORD1, "[FilePrint]")              && print merged document
  IF DDElasterror() <> 0             && if last dde not 0 call err routine
    DO FAXERR WITH DDElasterror()
    RETURN
  ENDIF

  = DDEExecute(WORD1, "[FileClose 2]")            && close old document
  IF DDElasterror() <> 0             && if last dde not 0 call err routine
    DO FAXERR WITH DDElasterror()
    RETURN
  ENDIF
ENDDO
Close databases
DELETE FILE MERGE.DBF
= DDEExecute(WORD1, "[FileExit 2]")      && quit word don't save
= DDETerminate(WORD1)                    && close channel
= DDETerminate(FAX1)                     && close channel
RETURN

PROCEDURE FAXERR
PARAMETER ERRNUM
  Close databases
  DELETE FILE MERGE.DBF
  = DDEExecute(WORD1, "[FileExit 2]")      && quit word don't save
  = DDETerminate(WORD1)                    && close channel
  = DDETerminate(FAX1)                     && close channel
  DO CASE
    CASE ERRNUM = 1
      WAIT "Service busy" window
    CASE ERRNUM = 2
      WAIT "Topic busy" window
    CASE ERRNUM = 3
      WAIT "Channel busy" window
    CASE ERRNUM = 4
      WAIT "No such service" window
    CASE ERRNUM = 5
      WAIT "No such topic" window
    CASE ERRNUM = 6
      WAIT "Bad channel" window
    CASE ERRNUM = 7
      WAIT "Insufficient memory" window
    CASE ERRNUM = 8
      WAIT "Acknowledge timeout" window
    CASE ERRNUM = 9
      WAIT "Request timeout" window
    CASE ERRNUM = 10
      WAIT "No DDEInitiate" window
    CASE ERRNUM = 11
      WAIT "Client attempted server transaction" window
    CASE ERRNUM = 12
      WAIT "Execute timeout" window
    CASE ERRNUM = 13
      WAIT "Bad parameter" window
    CASE ERRNUM = 14
      WAIT "Low memory" window
    CASE ERRNUM = 15
      WAIT "Memory error" window
    CASE ERRNUM = 16
      WAIT "Connect failure" window
    CASE ERRNUM = 17
      WAIT "Request failure" window
    CASE ERRNUM = 18
      WAIT "Poke timeout" window
    CASE ERRNUM = 19
      WAIT "Could not display message" window
    CASE ERRNUM = 20
      WAIT "Multiple synchronous transactions" window
    CASE ERRNUM = 21
      WAIT "Server died" window
    CASE ERRNUM = 22
      WAIT "Internal DDE error" window
    CASE ERRNUM = 23
      WAIT "Advise timeout" window
    CASE ERRNUM = 24
      WAIT "Invalid transaction identifier" window
    CASE ERRNUM = 25
      WAIT "Unknown error" window
    CASE ERRNUM = 26
      WAIT "Cannot Establish Channel" WINDOW
  ENDCASE
  RETURN
